/*******************************************************************
*
*  DESCRIPTION: class Puerta 
*
*  AUTHOR: Herrero Gustavo
*
*  EMAIL: mailto://gh4o@dc.uba.ar
*
*  DATE: 19/04/2002
*
*******************************************************************/

#ifndef __PUERTA_H
#define __PUERTA_H

/** include files **/
#include "atomic.h"     	// class Atomic
#include "atomicstate.h"	// class AtomicState
#include "VTime.hh"

/** forward declarations **/

class Puerta: public Atomic
{
public:
	Puerta( const string &name = "Puerta" );				  // Default constructor


	virtual string className() const
	{return "Puerta";}

protected:
	Model &initFunction() ;
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const CollectMessage & );

	//No special state variables are required for this model
	ModelState* allocateState() {
		return new AtomicState;
	}

private:
    // Parametros
    VTime       tiempo_apertura, tiempo_abrir_cerrar;
	
    //Variables internas
	int         estado_puerta;

	//Puertos de Entrada
	const Port  &abrir, &cerrar, &sensor;

    //Puerto de Salida
	Port        &estado;

};	// class Puerta



#endif   //__PUERTA_H 
